# We remove all default rules
.SUFFIXES:

CC = g++
CFLAGS = -W -Wall -Wextra -pedantic -std=c++14
LDFLAGS =
EXEC = main

all: mrproper run

build: parser demo_ice_detect

run: build
	rm -f *.o
	./parser.out
	./demo_ice_detect.out 2_calgary.txt 20 0.1

parser: parser.o
	$(CC) $(LDFLAGS) -o $@.out $^
count_min_tests: count_min_tests.o count_min.o hash_string.o
	$(CC) $(LDFLAGS) -o $@ $^
ice_detect: ice_detect.o entries_buffer.o entry.o controller.o router.o count_min.o hash_string.o
	$(CC) $(LDFLAGS) -o $@.out $^
demo_ice_detect: demo_ice_detect.o entries_buffer.o entry.o controller.o router.o count_min.o hash_string.o
	$(CC) $(LDFLAGS) -o $@.out $^
ice_detect.o: ice_detect.cpp controller.hpp router.hpp
	$(CC) -o $@ -c $< $(CFLAGS)
demo_ice_detect.o: demo_ice_detect.cpp controller.hpp router.hpp
	$(CC) -o $@ -c $< $(CFLAGS)
controller.o: controller.cpp controller.hpp router.hpp entry.hpp
	$(CC) -c $< $(CFLAGS)
entry.o: entry.cpp entry.hpp
	$(CC) -c $< $(CFLAGS)
router.o: router.cpp router.hpp entry.hpp entries_buffer.hpp
	$(CC) -c $< $(CFLAGS)
entries_buffer.o: entries_buffer.cpp entries_buffer.hpp entry.hpp
	$(CC) -c $< $(CFLAGS)
parser.o: parser.cpp
	$(CC) -o $@ -c $< $(CFLAGS)

hash_string.o: hash_string.cpp hash_string.hpp
	$(CC)  -c $< $(CFLAGS)

count_min.o: count_min.cpp count_min.hpp hash_string.hpp
	$(CC) -c $< $(CFLAGS)

count_min_tests.o: count_min_tests.cpp
	$(CC) -c $< $(CFLAGS)

#don't use -r is for directories and their contents
clean:
	@rm -rf *.o
	@rm -f *.txt

mrproper: clean
	@rm -f *.exe
	@rm -f $(EXEC)
	@rm -f *.out
